unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,ptin;

const
  kreis  = 0;
  RoundR = 1;
  ell    = 2;
  Poly   = 3;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
  private
    Form    : byte;
    Hotspot : TRect;
    RRHotspot : TRect;
    ry,rx   : integer;
    aPolygon: array of TPoint;
  public

  end;

var
  Form1: TForm1;
  aColor  : TColor = clyellow;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
 Form := kreis;
 Hotspot:= rect(100,100,200,200);
 Invalidate;
end;

procedure TForm1.Button2Click(Sender: TObject); //RoundRect
begin
  Form:= RoundR;
  Invalidate;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Form:= ell;
  Hotspot:= rect(100,100,300,200);
  Invalidate;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  form := Poly;
  setlength(aPolygon,4);
  aPolygon[0].X:= 100;
  aPolygon[0].Y:= 100;
  aPolygon[1].X:= 150;
  aPolygon[1].Y:= 150;
  aPolygon[2].X:= 190;
  aPolygon[2].Y:= 100;
  aPolygon[3].X:= 100;
  aPolygon[3].Y:= 100;
  Invalidate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 form := RoundR;
 Hotspot:= rect(100,100,200,200);
 rrHotspot:= rect(100,100,300,250); //width=200 height=150
 rx:= 200;
 ry:= 150;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var P : TPoint;
begin
  if form = kreis then
 begin
  if PointInCircle(Hotspot,x,y) then aColor := cllime else aColor:=clyellow;
 end;
 if form = RoundR then
  begin
   if PointInRoundRect(rrHotspot,x,y,rx,ry) then aColor := cllime else aColor:=clyellow;
  end;
 if form = ell then
 begin
  if PointInEllipse(Hotspot,x,y) then aColor := cllime else aColor:=clyellow;
 end;
 if Form = Poly then
  begin
   p.X:=x;p.Y:=y;
   if PtInPoly(aPolygon,p) then aColor := cllime else aColor:=clyellow;
  end;
 invalidate;
end;

procedure TForm1.FormPaint(Sender: TObject);
var checkrect,aRect : TRect;
begin
 canvas.Brush.Color:= aColor;

 if form = kreis  then canvas.Ellipse(Hotspot);
 //if form = RoundR then canvas.RoundRect(Hotspot,10,10);
 if form = RoundR then canvas.RoundRect(rrHotspot,rx,ry);

 {canvas.Brush.Style:= bsclear;
 aRect:=rrHotspot;

 checkRect := rect(aRect.Left+(rx div 2),aRect.Top,aRect.Right-(rx div 2),aRect.Bottom);
 canvas.Rectangle(checkRect);
 checkRect := rect(aRect.Left,aRect.Top+(ry div 2),aRect.Right,aRect.Bottom-(ry div 2));
 canvas.Rectangle(checkRect);

 checkRect := rect(aRect.Left,aRect.Top,aRect.Left+(aRect.Width div 2),aRect.Top+(aRect.Height div 2));
 canvas.Rectangle(checkRect);
 checkRect := rect(aRect.Left,aRect.Top,aRect.Left+rx,aRect.Top+ry);
 canvas.Ellipse(checkRect);

 checkRect := rect(aRect.Right-(aRect.Width div 2),aRect.Top,aRect.Right,aRect.Top+(aRect.Height div 2));
 canvas.Rectangle(checkRect);
 checkRect := rect(aRect.Right-rx,aRect.Top,aRect.Right,aRect.Top+ry);
 canvas.Ellipse(checkRect);

 checkRect := rect(aRect.Left,aRect.Top+(aRect.Height div 2),aRect.Left+(aRect.Width div 2),aRect.Bottom);
 canvas.Rectangle(checkRect);
 checkRect := rect(aRect.Left,aRect.Bottom-ry,aRect.Left+rx,aRect.Bottom);
 canvas.Ellipse(checkRect);

 checkRect := rect(aRect.Left+(aRect.Width div 2),aRect.Top+(aRect.Height div 2),aRect.Right,aRect.Bottom);
 canvas.Rectangle(checkRect);
 checkRect := rect(aRect.Right-rx,aRect.Bottom-ry,aRect.Right,aRect.Bottom);
 canvas.Ellipse(checkRect);
 }
 if form = ell    then canvas.Ellipse(Hotspot);
 if form = Poly   then canvas.Polygon(aPolygon);
end;

end.

